const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_balances = sequelize.define(
    'inventory_balances',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity_on_hand: {
        type: DataTypes.DECIMAL,
      
      

      },

quantity_reserved: {
        type: DataTypes.DECIMAL,
      
      

      },

last_counted_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_balances.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.inventory_balances.belongsTo(db.materials, {
      as: 'material',
      foreignKey: {
        name: 'materialId',
      },
      constraints: false,
    });

    db.inventory_balances.belongsTo(db.storage_locations, {
      as: 'location',
      foreignKey: {
        name: 'locationId',
      },
      constraints: false,
    });

    db.inventory_balances.belongsTo(db.inventory_lots, {
      as: 'inventory_lot',
      foreignKey: {
        name: 'inventory_lotId',
      },
      constraints: false,
    });




    db.inventory_balances.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_balances.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_balances;
};


